package com.example.demo.register;

import com.example.demo.annotation.MyAutowired;
import com.example.demo.annotation.MyComponent;
import com.example.demo.container.Container;
import com.example.demo.tools.test.Test;
import com.example.demo.utils.ScanFileTool;

import java.lang.reflect.Field;
import java.util.List;
import java.util.Map;

/**
 * Created by CN94740284 on 11/20/2020.
 */
public class Register {

    private static Container container = new Container();

    private static Container getContainer() {
        return container;
    }

    private static boolean regist(Class<?> clzz){
        Container container = Register.getContainer();
        Map<String, Object> tools = container.getTools();
        Object o = null;
        try {
            o = clzz.newInstance();
            tools.put(clzz.getName(),o);
            return true;
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return false;
    }

    private static boolean myAutowired(){
        Map<String, Object> tools = Register.getContainer().getTools();

        tools.forEach((key,value)->{
            Class<?> clzz = value.getClass();
            Field[] fs = clzz.getDeclaredFields();
            try {
                bindFields(value, fs, tools);
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        });

        return true;
    }

    public static <T> T getBean(Class<T> clzz){
        Map<String, Object> tools = Register.getContainer().getTools();
        T t = (T) tools.get(Test.class.getName());
        return t;
    }

    private static boolean bindFields(Object obj,Field[] fields,Map<String, Object> tools) throws IllegalAccessException {
        for (Field field : fields) {
            //获取属性上T类型的注解
            if(field.isAnnotationPresent(MyAutowired.class)) {
                Class<?> type = field.getType();
                Object tool = tools.get(type.getName());
                if(tool!=null){
                    field.setAccessible(true);
                    field.set(obj,tool);
                }else{
                    return false;
                }
            }
        }
        return true;
    }

    public static boolean registAndAutoBind(ScanFileTool t) {
        t.findClassLocal(ScanFileTool.STARATEGY_PATH);
        List<Class<? extends String>> eleStrategyList = t.getEleStrategyList();

        // 注册对象
        if(eleStrategyList!=null && eleStrategyList.size()>0){
            eleStrategyList.forEach((clzz)->{
                if(clzz.isAnnotationPresent(MyComponent.class)){
                    Register.regist(clzz);
                }
            });
        }

        // 绑定属性对象
        Register.myAutowired();

        return true;
    }
}
