package com.example.demo.utils;

import java.io.File;
import java.io.FileFilter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by CN94740284 on 11/20/2020.
 */
public class ScanFileTool {

    private Class<?> superStrategy = Object.class;//接口类class 用于过滤 可以不要

    private List<Class<? extends String>> eleStrategyList = new ArrayList<Class<? extends String>>();

    private ClassLoader classLoader = this.getClass().getClassLoader();//默认使用的类加载器

    public static final String STARATEGY_PATH = "com.example.demo.tools";//需要扫描的策略包名


    public List<Class<? extends String>> getEleStrategyList() {
        return eleStrategyList;
    }

    public void findClassLocal(final String packName){
        URI url;
        try {
            url = classLoader.getResource(packName.replace(".", "/")).toURI();
        } catch (URISyntaxException e1) {
            throw new RuntimeException("未找到策略资源");
        }

        File file = new File(url);

        file.listFiles(new FileFilter() {

            public boolean accept(File chiFile) {
                if(chiFile.isDirectory()){
                    findClassLocal(packName+"."+chiFile.getName());
                }
                if(chiFile.getName().endsWith(".class")){
                    Class<?> clazz = null;
                    try {
                        clazz = classLoader.loadClass(packName + "." + chiFile.getName().replace(".class", ""));
                        System.out.println(chiFile);
                    } catch (ClassNotFoundException e) {
                        e.printStackTrace();
                    }
                    if(superStrategy.isAssignableFrom(clazz)){
                        eleStrategyList.add((Class<? extends String>) clazz);
                    }
                    return true;
                }
                return false;
            }
        });

    }
}
